
#ifndef __Mod_GScript_Thread__
#define __Mod_GScript_Thread__

//---- [U[XbhǗW[
#module	mod_gs_thread \
	id, \
	c_uid, \
	c_order, \
	c_autobreak, \
	c_code, \
	c_address, \
	c_flag, \
	c_wait, \
	c_stat, \
	c_refdval, \
	c_refstr, \
	c_stack_index, \
	c_stack_type, \
	c_stack_code, \
	c_stack_address, \
	c_stack_max, \
	c_stack_count

	#modinit
		mod_GetID id
		c_uid			= _UID@ModGS_Temp & 0x7FFFF : _UID@ModGS_Temp++
		c_order			= 0
		c_autobreak		= -1

		c_code			= 0
		c_address		= 0	
		c_flag			= GSMD_THREAD_FLAG_EXECUTE_RUN
		c_wait			= 0
		c_stat			= 0
		c_refdval		= 0.0
		c_refstr		= ""

		c_stack_index	= 0
		dim c_stack_type, GSMD_THREAD_STACK_MAX
		dim c_stack_code, GSMD_THREAD_STACK_MAX
		dim c_stack_address, GSMD_THREAD_STACK_MAX
		dim c_stack_max, GSMD_THREAD_STACK_MAX
		dim c_stack_count, GSMD_THREAD_STACK_MAX

		return id

	#modcfunc _gs_thread_get_uid_from_sid
		return c_uid

	#modcfunc _gs_thread_get_tid_from_sid
		return ((c_uid << 12) + id)

	#modfunc _gs_thread_set_order int p0
		c_order = p0
		return
	#modcfunc _gs_thread_get_order
		return c_order

	#modfunc _gs_thread_set_autobreak int p0
		c_autobreak = p0
		return
	#modcfunc _gs_thread_get_autobreak
		return c_autobreak

	#modfunc _gs_thread_set_code int p0
		c_code = p0
		return

	#modcfunc _gs_thread_get_code
		return c_code

	#modfunc _gs_thread_set_address int p0
		c_address = p0
		return

	#modcfunc _gs_thread_get_flag
		return c_flag
	#modfunc _gs_thread_set_flag int p0
		c_flag = p0
		return

	#modfunc _gs_thread_set_stat int p0
		c_stat = p0
		return
	#modcfunc _gs_thread_get_stat
		return c_stat

	#modfunc _gs_thread_set_refdval double p0
		c_refdval = p0
		return
	#modcfunc _gs_thread_get_refdval
		return c_refdval

	#modfunc _gs_thread_set_refstr str p0
		c_refstr = p0
		return
	#modcfunc _gs_thread_get_refstr
		return c_refstr

	#modfunc _gs_thread_system_dup var p_code, var p_addr, var p_flag, var p_wait, var p_stat, var p_dval, var p_str
		dup p_code, c_code
		dup p_addr, c_address
		dup p_flag, c_flag
		dup p_wait, c_wait
		dup p_stat, c_stat
		dup p_dval, c_refdval
		dup p_str, c_refstr
		return

	#modfunc _gs_thread_stack_dup var p_index, var p_type, var p_code, var p_addr, var p_max, var p_count
		dup p_index, c_stack_index
		dup p_type, c_stack_type
		dup p_code, c_stack_code
		dup p_addr, c_stack_address
		dup p_max, c_stack_max
		dup p_count, c_stack_count
		return

#global

//	oXgl
#module linklist_value	m_value, m_prev, m_next
	#modinit int p_value, int p_prev, int p_next
		mref _mref@ModGS_Temp,2
		m_value = p_value
		m_prev = p_prev
		m_next = p_next
		return _mref@ModGS_Temp

	#modfunc linklist_value_set_value int p_value
		m_value = p_value
		return
	#modfunc linklist_value_set_prev int p_prev
		m_prev = p_prev
		return
	#modfunc linklist_value_set_next int p_next
		m_next = p_next
		return

	#modcfunc linklist_value_get_value
		return m_value
	#modcfunc linklist_value_get_prev
		return m_prev
	#modcfunc linklist_value_get_next
		return m_next

#global



#module "ModGS_Thread"	//	Gmd_Thread_Container@ModGS_Thread

	#deffunc gs_thread_create_container
		dimtype Gmd_Thread_Container, 5, 1
		dimtype Gmd_Thread_Order, 5, 1
		order_top = -1
		order_last = -1
		return

//	thread order

	//	Ōɒǉ
	#deffunc gs_thread_order_add int p_value, local p_prev, local p_id
		newmod Gmd_Thread_Order@ModGS_Thread, linklist_value, p_value, order_last, -1
		p_id = stat
		p_prev = linklist_value_get_prev(Gmd_Thread_Order@ModGS_Thread(p_id))
		if p_prev != -1 {
			linklist_value_set_next Gmd_Thread_Order@ModGS_Thread(p_prev), p_id
		}
		order_last = p_id
		if order_top == -1 {
			order_top = p_id
		}
		return p_id

	//	Xbh폜ꂽꍇɂ̃XbhsȂ _gsc_thread_order ̈ʒu߂
	#deffunc gs_thread_order_core_check int p_index
		if _gsc_thread_order == p_index {	//	ΏۃXbhs
			_gsc_thread_order = linklist_value_get_prev(Gmd_Thread_Order@ModGS_Thread(p_index))
		}
		return

	//	XbhI[_[폜
	#deffunc gs_thread_order_del int p_index, local p_prev, local p_next
		gs_thread_order_core_check p_index
		p_prev = linklist_value_get_prev(Gmd_Thread_Order@ModGS_Thread(p_index))
		p_next = linklist_value_get_next(Gmd_Thread_Order@ModGS_Thread(p_index))
		if p_prev != -1 {
			linklist_value_set_next Gmd_Thread_Order@ModGS_Thread(p_prev), p_next
		} else {
			order_top = p_next
		}
		if p_next != -1 {
			linklist_value_set_prev Gmd_Thread_Order@ModGS_Thread(p_next), p_prev
		} else {
			order_last = p_prev
		}
		delmod Gmd_Thread_Order@ModGS_Thread(p_index)
		return

	//	wCfbNX玟̃CfbNX擾
	#defcfunc gs_thread_order_get_next int p_index, local p_ret
		p_ret = 0
		if p_index < 0 {
			if p_index == -1 : p_ret = order_top	//	擪擾
			if p_index == -2 : p_ret = order_last	//	Ō擾
		} else {
			//	w肳ꂽCfbNX̎擾
			p_ret = linklist_value_get_next(Gmd_Thread_Order@ModGS_Thread(p_index))
		}
		return p_ret

	//	XbhI[_[̒liThreadIDj擾
	#defcfunc gs_thread_order_get_value int p_index
		if p_index < 0 : return 0
		return linklist_value_get_value(Gmd_Thread_Order@ModGS_Thread(p_index))

#if GSMD_DEBUG
	//	fobOp
	#defcfunc gs_thread_order_info local str_temp
		str_temp = ""
		foreach Gmd_Thread_Order@ModGS_Thread
			str_temp += ""+linklist_value_get_prev(Gmd_Thread_Order@ModGS_Thread(cnt))+" ["+cnt+":"+linklist_value_get_value(Gmd_Thread_Order@ModGS_Thread(cnt))+"] "+linklist_value_get_next(Gmd_Thread_Order@ModGS_Thread(cnt))+"\n"
		loop
		str_temp = "top:"+order_top+"\nlast:"+order_last+"\n"+str_temp
		return str_temp
#endif


//	thread main

	#deffunc gs_thread_clear
		foreach Gmd_Thread_Container@ModGS_Thread
			gs_thread_order_del _gs_thread_get_order(Gmd_Thread_Container@ModGS_Thread(cnt))	//	modtermɂ͑gݍ܂Ȃ
			delmod Gmd_Thread_Container@ModGS_Thread(cnt)
		loop
		return

	#deffunc gs_thread_init
		if vartype(Gmd_Thread_Container@ModGS_Thread) == 5 {
			gs_thread_clear
		} else {
			gs_thread_create_container
		}
		return

	//	systemID	sid	0x00000FFF	zID
	//	uniqueID	uid	0x7FFFF000	ŗLʗp
	//	threadID	tid	(uniqueID << 12) + systemID

	//	threadID -> systemID
	#defcfunc gs_thread_get_sid_from_tid int p0, local systemID, local uniqueID
		systemID = p0 & 0xFFF : uniqueID = p0 >> 12
		if varuse(Gmd_Thread_Container@ModGS_Thread(systemID)) == 0 : return -1
		if _gs_thread_get_uid_from_sid(Gmd_Thread_Container@ModGS_Thread(systemID)) != uniqueID : return -1
		return systemID
	
	//	systemID -> threadID
	// _gs_thread_get_tid_from_sid(Gmd_Thread_Container@ModGS_Thread(id))

	//	systemID -> uniqueID
	// _gs_thread_get_uid_from_sid(Gmd_Thread_Container@ModGS_Thread(id))

	//	Xbh쐬
	#defcfunc gs_thread_create local systemID
		newmod Gmd_Thread_Container@ModGS_Thread, mod_gs_thread
		systemID = stat
		if systemID > 0xFFF {	//	4095
			delmod Gmd_Thread_Container@ModGS_Thread(systemID)
			systemID = -1
		} else {
			gs_thread_order_add systemID
			_gs_thread_set_order Gmd_Thread_Container@ModGS_Thread(systemID), stat
			systemID = _gs_thread_get_tid_from_sid(Gmd_Thread_Container@ModGS_Thread(systemID))
		}
		return systemID

	//	Xbh폜
	#deffunc gs_thread_delete int p0, local systemID
		systemID = gs_thread_get_sid_from_tid(p0) : if systemID == -1 : return -1
		gs_thread_order_del _gs_thread_get_order(Gmd_Thread_Container@ModGS_Thread(systemID))	//	modtermɂ͑gݍ܂Ȃ
		delmod Gmd_Thread_Container@ModGS_Thread(systemID)
		return 0

	//	Cӂ̃R[hQƂĂXbh폜
	#deffunc gs_thread_delete_by_code int p0
		foreach Gmd_Thread_Container@ModGS_Thread
			if _gs_thread_get_code(Gmd_Thread_Container@ModGS_Thread(cnt)) == p0 {
				gs_thread_order_del _gs_thread_get_order(Gmd_Thread_Container@ModGS_Thread(cnt))	//	modtermɂ͑gݍ܂Ȃ
				delmod Gmd_Thread_Container@ModGS_Thread(cnt)
			}
		loop
		return 0

	//	XbhɃR[h̐擪ݒ
	#deffunc gs_thread_set_code int p0, int p1, local systemID
		systemID = gs_thread_get_sid_from_tid(p0) : if systemID == -1 : return -1

		_gs_thread_set_code Gmd_Thread_Container@ModGS_Thread(systemID), p1
		return 0

	//	XbhɃxʒuݒixj
	#deffunc gs_thread_set_label int p0, str p1, local systemID, local labelID
		systemID = gs_thread_get_sid_from_tid(p0) : if systemID == -1 : return -1
	
		labelID = gs_label_search(p1)
		if labelID == -1 : return -2
		_gs_thread_set_code Gmd_Thread_Container@ModGS_Thread(systemID), gs_label_get_code(labelID)
		_gs_thread_set_address Gmd_Thread_Container@ModGS_Thread(systemID), gs_label_get_address(labelID)
		return 0

	//	XbhɃxʒuݒixIDj
	#deffunc gs_thread_set_labelid int p0, int labelID, local systemID
		systemID = gs_thread_get_sid_from_tid(p0) : if systemID == -1 : return -1
		_gs_thread_set_code Gmd_Thread_Container@ModGS_Thread(systemID), gs_label_get_code(labelID)
		_gs_thread_set_address Gmd_Thread_Container@ModGS_Thread(systemID), gs_label_get_address(labelID)
		return 0

	//	Xbh̐
	#defcfunc gs_thread_get_thread_count local count
		count = 0
		foreach Gmd_Thread_Container@ModGS_Thread
			count++
		loop
		return count

	//	Xbh̏
	#defcfunc gs_thread_get_thread_state int p0, local systemID, local ret
		systemID = gs_thread_get_sid_from_tid(p0)
		if systemID != -1 {
			ret = _gs_thread_get_flag(Gmd_Thread_Container@ModGS_Thread(systemID))
		} else {
			ret = -1
		}
		return ret

	//	Xbh̃tOݒ
	#deffunc gs_thread_set_flag int p0, int p_flag, int p_mask, local systemID, local ret
		systemID = gs_thread_get_sid_from_tid(p0) : if systemID == -1 : return -1
		_gs_thread_set_flag Gmd_Thread_Container@ModGS_Thread(systemID), (_gs_thread_get_flag(Gmd_Thread_Container@ModGS_Thread(systemID))^p_mask)|(p_flag&p_mask)
		return

	#define global ctype	gs_thread_get_tid_from_sid(%1)		_gs_thread_get_tid_from_sid(Gmd_Thread_Container@ModGS_Thread(%1))
	#define global			gs_thread_set_autobreak(%1,%2)		_gs_thread_set_autobreak Gmd_Thread_Container@ModGS_Thread(gs_thread_get_sid_from_tid(%1)), %2
	#define global ctype	gs_thread_get_autobreak(%1)			_gs_thread_get_autobreak(Gmd_Thread_Container@ModGS_Thread(gs_thread_get_sid_from_tid(%1)))
	#define global			gs_thread_set_stat(%1,%2)			_gs_thread_set_stat Gmd_Thread_Container@ModGS_Thread(gs_thread_get_sid_from_tid(%1)), %2
	#define global ctype	gs_thread_get_stat(%1)				_gs_thread_get_stat(Gmd_Thread_Container@ModGS_Thread(gs_thread_get_sid_from_tid(%1)))
	#define global			gs_thread_set_refdval(%1,%2)		_gs_thread_set_refdval Gmd_Thread_Container@ModGS_Thread(gs_thread_get_sid_from_tid(%1)), %2
	#define global ctype	gs_thread_get_refdval(%1)			_gs_thread_get_refdval(Gmd_Thread_Container@ModGS_Thread(gs_thread_get_sid_from_tid(%1)))
	#define global			gs_thread_set_refstr(%1,%2)			_gs_thread_set_refstr Gmd_Thread_Container@ModGS_Thread(gs_thread_get_sid_from_tid(%1)), %2
	#define global ctype	gs_thread_get_refstr(%1)			_gs_thread_get_refstr(Gmd_Thread_Container@ModGS_Thread(gs_thread_get_sid_from_tid(%1)))
	#define global ctype	gs_thread_get_code(%1)				_gs_thread_get_code(Gmd_Thread_Container@ModGS_Thread(gs_thread_get_sid_from_tid(%1)))
	#define global			gs_thread_set_address(%1,%2)		_gs_thread_set_address Gmd_Thread_Container@ModGS_Thread(gs_thread_get_sid_from_tid(%1)), %2

	;#define global ctype	gs_thread_get_flag(%1)				_gs_thread_get_flag(Gmd_Thread_Container@ModGS_Thread(gs_thread_get_sid_from_tid(%1)))
	;#define global			gs_thread_set_flag(%1,%2)			_gs_thread_set_flag Gmd_Thread_Container@ModGS_Thread(gs_thread_get_sid_from_tid(%1)), %2

	#define global			gs_thread_system_dup(%1,%2,%3,%4,%5,%6,%7,%8)	_gs_thread_system_dup Gmd_Thread_Container@ModGS_Thread(gs_thread_get_sid_from_tid(%1)),%2,%3,%4,%5,%6,%7,%8
	#define global			gs_thread_stack_dup(%1,%2,%3,%4,%5,%6,%7)	_gs_thread_stack_dup Gmd_Thread_Container@ModGS_Thread(gs_thread_get_sid_from_tid(%1)),%2,%3,%4,%5,%6,%7


#global

gs_thread_init



#define global ctype	gsc_thread_Create				gs_thread_create()
#define global			gsc_thread_Delete(%1)			gs_thread_delete %1
#define global			gsc_thread_SetCode(%1,%2)		gs_thread_set_code %1,%2
#define global			gsc_thread_SetLabel(%1,%2)		gs_thread_set_label %1,%2
#define global			gsc_thread_SetLabelId(%1,%2)	gs_thread_set_labelid %1,%2

#define global ctype	gsc_thread_GetCount				gs_thread_get_thread_count()
#define global ctype	gsc_thread_GetState(%1)			gs_thread_get_thread_state(%1)
#define global			gsc_thread_SetBreak(%1,%2)		gs_thread_set_autobreak %1,%2

#define global			gsc_thread_SetStat(%1,%2)		gs_thread_set_stat %1,%2
#define global ctype	gsc_thread_GetStat(%1)			gs_thread_get_stat(%1)

#define global			gsc_thread_SetRefdval(%1,%2)	gs_thread_set_refdval %1,%2
#define global ctype	gsc_thread_GetRefdval(%1)		gs_thread_get_refdval(%1)

#define global			gsc_thread_SetRefstr(%1,%2)		gs_thread_set_refstr %1,%2
#define global ctype	gsc_thread_GetRefstr(%1)		gs_thread_get_refstr(%1)

#define global			gsc_thread_Run(%1,%2=1)			gs_thread_set_flag %1, %2, GSMD_THREAD_FLAG_MASK_EXECUTE
#define global			gsc_thread_Stop(%1,%2=0)		gs_thread_set_flag %1, %2, GSMD_THREAD_FLAG_MASK_EXECUTE

#endif
